import "core-js/modules/web.dom.iterable";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { Component } from 'react';
import BlockUi from 'react-block-ui';
import { createHoc } from 'react-common-kit';
export default function withBlockUi(config = {}) {
  const {
    loader,
    keepInView = true,
    sourceStateName = 'source'
  } = config,
        otherProps = _objectWithoutProperties(config, ["loader", "keepInView", "sourceStateName"]);

  return createHoc(TargetComponent =>
  /* eslint-disable react/prefer-stateless-function */
  class WithBlockUi extends Component {
    render() {
      const {
        [sourceStateName]: {
          isPending
        }
      } = this.props;
      return React.createElement(BlockUi, _extends({}, otherProps, {
        blocking: isPending,
        tag: "div",
        loader: loader,
        keepInView: keepInView
      }), React.createElement(TargetComponent, this.props));
    }

  }
  /* eslint-enable react/prefer-stateless-function */
  );
}